; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp
	; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp   
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	1ms TIMER																	
;																				
TIM0_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
	push TEMP2
	push ZL
	push ZH
; ----------------------------------
; TIMER0 Startwert					
	ldi temp, TIMERWERT0
	out TCNT0,temp
	; Zeit	
	rcall ZEIT
	; DIGIT	
	rcall DIGIT
; ----------------------------------
	pop ZH
	pop ZL
	pop TEMP2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT:
; DIGITS alle aus						
	out PORTB,NULL
; ----------------------------------
	LDS temp,(adr_LED_ZAEHLER)	; ZHLER laden		
	inc temp					; +1	
	STS (adr_LED_ZAEHLER),temp	; ZHLER schreiben	
	; Helligkeit	
	LDS temp1,(adr_LED_HELLIGKEIT)
	cp temp,temp1				; vergleich 		
	brlo TIM0_DIGIT_0			; ist kleiner		
	breq TIM0_DIGIT_0			; ist gleich		
	clr temp
	STS (adr_LED_ZAEHLER),temp	; ZHLER schreiben	 = 0 (rechte Stelle)
; ----------------------------------
TIM0_DIGIT_0:
	cpi temp,0					; vergleich				
	brne TIM0_DIGIT_1
	LDS temp,(adr_LED_DIGIT_0)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,0					; STELLE-0 = EIN
	ret
TIM0_DIGIT_1:
	cpi temp,1					; vergleich				
	brne TIM0_DIGIT_2
	LDS temp,(adr_LED_DIGIT_1)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,1					; STELLE-1 = EIN
	ret
TIM0_DIGIT_2:
	cpi temp,2					; vergleich				
	brne TIM0_DIGIT_3
	LDS temp,(adr_LED_DIGIT_2)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,2					; STELLE-2 = EIN
	ret
TIM0_DIGIT_3:
	cpi temp,3
	brne TIM0_DIGIT_4
	LDS temp,(adr_LED_DIGIT_3)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,3					; STELLE-3 = EIN
	ret
TIM0_DIGIT_4:
	cpi temp,4					; vergleich				
	brne TIM0_DIGIT_5
	LDS temp,(adr_LED_DIGIT_4)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,4					; STELLE-4 = EIN
	ret
TIM0_DIGIT_5:
	cpi temp,5					; vergleich				
	brne TIM0_DIGIT_FERTIG
	LDS temp,(adr_LED_DIGIT_5)	; WERT DIGIT 0 laden 	
	out PORTD,temp				; setzen				
	sbi PORTB,5					; STELLE-5 = EIN
TIM0_DIGIT_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:
; Vorteiler 10:1		
ZEIT_ss_VT:
	LDS temp,(adr_ss_VT)	; aus SRAM laden			
	inc temp				; +1						
	STS (adr_ss_VT),temp	; in SRAM speichern			
	cpi temp,10				; vergleich mit 10			
	brsh ZEIT_SS_100		; ist gleich oder grer	
	ret						; zurck					
; 100-el Sekunden		
ZEIT_SS_100:
	STS (adr_ss_VT),NULL	; NULL						
	
;-----------------------
	rcall DCF_PIN_ABFRAGEN
	rcall DCF_PIN_PEGELWECHSEL_ERKENNUNG
	rcall DCF_IMPULSLAENGE
	rcall DCF_SEKUNDENTAKT

;-----------------------
	LDS temp,(adr_ss_100)	; aus SRAM laden			
	inc temp				; +1						
	STS (adr_ss_100),temp	; in SRAM speichern			
	cpi temp,100			; vergleich mit 100			
	brsh ZEIT_SS			; ist gleich oder grer	
	ret						; zurck					
; Sekunden				
ZEIT_SS:
	STS(adr_ss_100),NULL

	LDS temp,(adr_ss)	; aus SRAM laden	
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
; Minuten				
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	

	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
; Stunden				
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	

	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
; TAG					
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	

	LDS temp,(adr_TAG)	; aus SRAM laden	
	inc temp
	STS (adr_TAG),temp	; in SRAM speichern	
	
	rcall ZEIT_TAGE_IM_MONAT
	cp temp,temp1 
	brsh ZEIT_MONAT
	ret
; MONAT					
ZEIT_MONAT:
	STS (adr_TAG),EINS

	LDS temp,(adr_MONAT); aus SRAM laden	
	inc temp
	STS (adr_MONAT),temp; in SRAM speichern	
	cpi temp,13 
	brsh ZEIT_JAHR
	ret
; JAHR					
ZEIT_JAHR:
	STS (adr_MONAT),EINS

	LDS temp,(adr_JAHR)	; aus SRAM laden	
	inc temp
	STS (adr_JAHR),temp	; in SRAM speichern	

ret
; Anzahl der TAGE im Monat	
ZEIT_TAGE_IM_MONAT:
	LDS temp1,(adr_MONAT)

ZEIT_TAGE_IM_MONAT_01:			; Januar	
	cpi temp1,1
	brne ZEIT_TAGE_IM_MONAT_02
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_02:			; Februar	
	cpi temp1,2
	brne ZEIT_TAGE_IM_MONAT_03
	ldi temp1,28
	ret
ZEIT_TAGE_IM_MONAT_03:			; Mrz		
	cpi temp1,3
	brne ZEIT_TAGE_IM_MONAT_04
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_04:			; April		
	cpi temp1,4
	brne ZEIT_TAGE_IM_MONAT_05
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_05:			; Mai		
	cpi temp1,5
	brne ZEIT_TAGE_IM_MONAT_06
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_06:			; Juni		
	cpi temp1,6
	brne ZEIT_TAGE_IM_MONAT_07
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_07:			; Juli		
	cpi temp1,7
	brne ZEIT_TAGE_IM_MONAT_08
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_08:			; August	
	cpi temp1,8
	brne ZEIT_TAGE_IM_MONAT_09
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_09:			; September	
	cpi temp1,8
	brne ZEIT_TAGE_IM_MONAT_10
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_10:			; Oktober	
	cpi temp1,10
	brne ZEIT_TAGE_IM_MONAT_11
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_11:			; November	
	cpi temp1,11
	brne ZEIT_TAGE_IM_MONAT_12
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_12:			; Dezember	
	ldi temp1,31
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


