;												
; DCF77 Empfnger + 7 Segment-Anzeige			
; Bernhard.Erfurt@gmx.de						
; 09/2009										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 7-SEGMENT	Digit-0 (rechts)			
; PB1 ==> 7-SEGMENT	Digit-1						
; PB2 ==> 7-SEGMENT	Digit-2						
; PB3 ==> 7-SEGMENT	Digit-3						
; PB4 ==> 7-SEGMENT	Digit-4						
; PB5 ==> 7-SEGMENT	Digit-5						
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==>  										
; PC1 ==> 										
; PC2 ==> DCF-EINGANG							
; PC3 ==> LED GRN								
; PC4 ==> LED GELB								
; PC5 ==> LED ROT								
;												
; PD0 ==> 7-SEGMENT Balken A					
; PD1 ==> 7-SEGMENT Balken B					
; PD2 ==> 7-SEGMENT Balken C					
; PD3 ==> 7-SEGMENT Balken D					
; PD4 ==> 7-SEGMENT Balken E					
; PD5 ==> 7-SEGMENT Balken F					
; PD6 ==> 7-SEGMENT Balken G					
; PD7 ==> 7-SEGMENT Balken DP					
;												


; ATmega8 										
.include "m8def.inc"
; LEDS 											
.equ LED_C_GRUEN		= 3
.equ LED_C_GELB			= 4
.equ LED_C_ROT			= 5
; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; TIMER-WERTE					
.equ TIMERWERT0 =256-250			;(2 hoch 8  minus 250)		bei 16MHz + Vorteiler   64 => 0.001s 	

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_ss_VT					=0x0060+8			; Vorteiler	
.equ adr_ss_100					=0x0060+9			; 100-el	
.equ adr_ss						=0x0060+10			; Sekunden	
.equ adr_mm						=0x0060+11			; Minuten	
.equ adr_hh						=0x0060+12			; Stunden	
.equ adr_TAG					=0x0060+13			; Tag		
.equ adr_WOCHENTAG				=0x0060+14			; WochenTag	
.equ adr_MONAT					=0x0060+15			; Monat		
.equ adr_JAHR					=0x0060+16			; Jahr		
.equ adr_SOMMERZEIT				=0x0060+17			; SOMMERZEIT

.equ adr_LED_HELLIGKEIT			=0x0060+29			; Helligkeit		
.equ adr_LED_ZAEHLER			=0x0060+30			; interner Zhler	
.equ adr_LED_DIGIT_0			=0x0060+31			; DIGIT				
.equ adr_LED_DIGIT_1			=0x0060+32			; DIGIT				
.equ adr_LED_DIGIT_2			=0x0060+33			; DIGIT				
.equ adr_LED_DIGIT_3			=0x0060+34			; DIGIT				
.equ adr_LED_DIGIT_4			=0x0060+35			; DIGIT				
.equ adr_LED_DIGIT_5			=0x0060+36			; DIGIT				

.equ adr_DCF_PEGEL				=0x0060+100			; DCF-Pegel am PIN			
.equ adr_DCF_PEGEL_OLD			=0x0060+101			; DCF-Pegel am PIN			
.equ adr_DCF_PEGEL_WECHSEL		=0x0060+102			; bei Pegel-Wechsel=1		

.equ adr_DCF_IMPULSLAENGE		=0x0060+109			; DCF gemessene Impulslnge	
.equ adr_DCF_IMPULSLAENGE_AN	=0x0060+110			; DCF Empulslnge Trger an	
.equ adr_DCF_IMPULSLAENGE_AUS	=0x0060+111			; DCF Empulslnge Trger aus
.equ adr_DCF_BIT				=0x0060+112			; DCF-BIT					

.equ adr_DCF_ERKANNT			=0x0060+117			; DCF nach einschalten erkannt	
.equ adr_DCF_GUELTIG			=0x0060+118			; DCF-Protokoll gltig			
.equ adr_DCF_ANZAHL_FEHLER		=0x0060+119			; DCF-Protolkoll Fehler			
.equ adr_DCF_ZEIGER				=0x0060+120			; Zeiger fr DCF-FELD			
.equ adr_DCF_BEREICH			=0x0060+130	 		; 60 BIT fr DCF-FELD			

; REGISTER										
.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF			;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	sbi PORTC, LED_C_GRUEN	; aus	
	sbi PORTC, LED_C_GELB	; aus	
	cbi PORTC, LED_C_ROT	; an	
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00111111	; 7-Segment LED
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00111111	; LOW
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00111000	; ROT/GELB/GRN / DCF
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00111000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111	; 7-Segment LED
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; LOW
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR

; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
     

; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; Helligkeit		
	ldi temp,5	; 5...30
	STS (adr_LED_HELLIGKEIT),temp
	; ZEIT				
	ldi temp,23
	STS(adr_hh),temp
	ldi temp,59
	STS(adr_mm),temp
	ldi temp,25
	STS(adr_ss),temp
	; DATUM				
	ldi temp,31
	STS(adr_TAG),temp
	ldi temp,12
	STS(adr_MONAT),temp
	ldi temp,0
	STS(adr_JAHR),temp


; LED-TEST											
	cbi PORTC, LED_C_GRUEN	; an	
	rcall wait_100ms
	cbi PORTC, LED_C_GELB	; an	
	rcall wait_100ms
	cbi PORTC, LED_C_ROT	; an	
	rcall wait_100ms
	sbi PORTC, LED_C_GRUEN	; aus	
	sbi PORTC, LED_C_GELB	; aus	
	sbi PORTC, LED_C_ROT	; aus	
; interrupts freigeben								
	sei
; LEDs												
	cbi PORTC, LED_C_ROT	; an	

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	

	rcall STEUERUNG_ANZEIGE

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
STEUERUNG_ANZEIGE:

	; nur beim einschalten der Uhr
STEUERUNG_ANZEIGE_EINSCHALTEN:
	LDS temp,(adr_DCF_ERKANNT)
	tst temp
	brne STEUERUNG_ANZEIGE_NORMAL
	; DCF ZEIGER und Fehler anzeigen
	rcall DCF_ZEIGER_UND_FEHLER_ANZEIGEN
	ret
STEUERUNG_ANZEIGE_NORMAL:
	LDS temp,(adr_ss)

	ldi ZL,low (STEUERUNG_ANZEIGE_SPRUNGMARKE)
	ldi ZH,high(STEUERUNG_ANZEIGE_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	ijmp 
STEUERUNG_ANZEIGE_SPRUNGMARKE:
	; 0
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	; 10
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	; 20
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	; 30
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	rjmp STEUERUNG_ANZEIGE_DATUM
	; 40
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	; 50
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT
	rjmp STEUERUNG_ANZEIGE_ZEIT



STEUERUNG_ANZEIGE_ZEIT:
	rcall ZEIT_ANZEIGEN
	ret
STEUERUNG_ANZEIGE_DATUM:
	rcall DATUM_ANZEIGEN
	ret

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "LED_TIMER.asm"
.include "LED_SONSTIGES.asm"
.include "LED_LED.asm"
.include "LED_DCF.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################

